
{ 4I22 DEMO SOFTWARE }


{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }
{$N-}    {No numeric coprocessor}
{$L+}    {Generate Symbols}
{$F+}    {Far calls}

{$I 4I22LOW }                 { include low level 4I22 I/O }

{ program eventcount }

var
Count : word;
OldCount : word;


procedure SetUpEventCounter;

begin
  SetCounterMode(Counter1A,PeriodicInt);   { event counter }
  LoadCounter(Counter1A,0);
end; { SetUpEventCounter }



function NullCount(TimerPort : word) : boolean;
var tstatus : byte;

begin
  ReadCounterStatus(TimerPort,tstatus);
  NullCount := (( tstatus and NullCountMask ) = NullCountMask);
end; { NullCount }



procedure DisplayCount;

begin
  repeat
    if NullCount(Counter1A)                 { if counter not loaded (no clock yet), }
                                            { don't read because data is invalid }
    then
      count := 0
    else
    begin
      LatchCounter(Counter1A);
      ReadCounter(Counter1A,Count);
      Count := not Count + 1;             { compensate for down counting }
    end;
    if Count <> OldCount then             { only update display if changed }
    begin
      write(#13);
      write('          ');
      write(#13);
      write(Count);
      OldCount := Count
    end;
  until 2=3;
end; { DisplayCount }


begin
  SetUpEventCounter;
  writeln('Counter started ... press control break to stop');
  writeln('');
  DisplayCount;
end.