
{ 4I22 DEMO SOFTWARE }


{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }
{$N-}    {No numeric coprocessor}
{$L+}    {Generate Symbols}
{$F+}    {Far calls}

{$I 4I22LOW }                 { include low level 4I22 I/O }

{ program frequency }

var

Frequency : word;

{ Frequency counter demo -- Timer 3C used as gate prescaler, timer 1C used
  to trigger gate generator timer 1B. Timer 1A used as actual frequency
  counter. You must accordingly jumper timers to use internal prescaler,
  and connect timer 1C out to timer 1B gate, and connect timer 1B out to
  timer 1A gate input is timer 1A clock (jumper it for external source)  }




procedure SetUpFreqCounter;

begin
  SetCounterMode(Counter3C,RateGenerator); { Set up reference rate of 1 KHz }
  LoadCounter(Counter3C,10000);            { to allow long gate times }

  SetCounterMode(Counter1C,SoftwStrobe);   { Set up to tweak gate generator }
  LoadCounter(Counter1C,4);                { could use PPI bit but too lazy... }

  SetCounterMode(Counter1B,HardwOneShot);  { Gate generator one shot }
  LoadCounter(Counter1B,100);              { set to 100 msec }

  SetCounterMode(Counter1A,PeriodicInt);   { Actual frequency counter }
  LoadCounter(Counter1A,0);
end; { SetupFreqCounter }



procedure nothing;

begin
end; { nothing }



function OutputHigh(TimerPort : word) : boolean;
var tstatus : byte;

begin
  ReadCounterStatus(TimerPort,tstatus);
  OutputHigh := (( tstatus and OutbitMask ) = OutbitMask);
end; { OutputHigh }



procedure GateGen;

begin
  LoadCounter(Counter1C,4);
  while OutputHigh(Counter1B) do nothing;         { Wait for start of gate pulse }
  while not OutputHigh(Counter1B) do nothing;     { Wait for end of gate pulse }
end; { GateGen }




function NullCount(TimerPort : word) : boolean;
var tstatus : byte;

begin
  ReadCounterStatus(TimerPort,tstatus);
  NullCount := (( tstatus and NullCountMask ) = NullCountMask);
end; { NullCount }



procedure ReadFreq;

begin
  repeat
    LoadCounter(Counter1A,0);               { Clear the frequency counter }
    GateGen;                                { Strobe the gate generator one shot }
    while not OutputHigh(Counter1B) do nothing; { Wait for gate to go away (high) }
    if NullCount(Counter1A)
    then
      Frequency := 0
    else
      begin
        ReadCounter(Counter1A,Frequency);
        Frequency := not Frequency + 1;     { compensate for down counting }
      end;
    write(#13);
    write('          ');
    write(#13);
    write(Frequency);
  until 2=3;
end; { ReadFreq }


begin
  SetUpFreqCounter;
  writeln('Counter started ... press control break to stop');
  writeln('');
  ReadFreq;
end.