
{ 4I22 DEMO SOFTWARE }

program PWM4I22;

{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }
{$N-}    {No numeric coprocessor}
{$L+}    {Generate Symbols}
{$F+}    {Far calls}



{$I 4I22LOW }                 { include low level 4I22 I/O }

{ 10 bit PWM demo -- you must jumper 4I22 to use 10 MHz for counter in's
  ( no prescaler ) and connect timer 1B gate to output of timer 1A }



procedure SetUpPWM;

begin
{ Set up counter 1A as 10 MHz / 1024 = 9.766 KHz square wave as reference }

  SetCounterMode(Counter1A,RateGenerator);
  LoadCounter(Counter1A,1024);            { set up reference rate }

{ set up counter 1B as programmable one-shot to generate PWM }

  SetCounterMode(Counter1B,HardwOneShot);
  LoadCounter(Counter1B,512);             { square wave for now }
end; { SetupPWM }



procedure WasteTime;
var loopcount : integer;

begin
  loopcount := 0;
  while loopcount < 25 do loopcount := loopcount + 1 ;
end; {WasteTime}



procedure VaryPWM;
var PulseWidth : word;

begin
  PulseWidth :=1;                           { 1 is minimum, 0 is maximum! = 1024 }
  repeat
    while PulseWidth <  1024 do
    begin
      LoadCounter(Counter1B,PulseWidth);
      PulseWidth := PulseWidth + 1;
      WasteTime;
    end;
    write('*');
    while PulseWidth > 1 do
    begin
      LoadCounter(Counter1B,PulseWidth);
      PulseWidth := PulseWidth - 1;
      WasteTime;
    end;
    write('*');
  until 2=3;
end; {VaryPWM}


begin
  SetUpPWM;
  Writeln('PWM started ... press control break to stop');
  VaryPWM;
end.