
{ 4I22 DEMO SOFTWARE }

program SQUARE4I22;

{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }
{$N-}    {No numeric coprocessor}
{$L+}    {Generate Symbols}
{$F+}    {Far calls}

{$I 4I22LOW }                 { include low level 4I22 I/O }

{ Set prescaler (counter 3C) to 100K Hz square wave
  set all other counters to squarewave mode with various frequencies
  this assumes that all counters have their inputs jumpered to the
  internal clock source (prescaler). This is the default 4I22 configuration }
begin
  SetCounterMode(Counter3C,SquareWave);
  LoadCounter(Counter3C,100);            { 100K Hz = 10M Hz / 100 }
  SetCounterMode(Counter1A,SquareWave);
  LoadCounter(Counter1A,100);            { 1K Hz = 100K Hz / 100 }
  SetCounterMode(Counter1B,SquareWave);
  LoadCounter(Counter1B,200);            { 500 Hz = 100K Hz / 200 }
  SetCounterMode(Counter1C,SquareWave);
  LoadCounter(Counter1C,400);            { 250 Hz = 100K Hz / 400 }
  SetCounterMode(Counter2A,SquareWave);
  LoadCounter(Counter2A,800);            { 125 Hz = 100K Hz / 800 }
  SetCounterMode(Counter2B,SquareWave);
  LoadCounter(Counter2B,1600);           { 62.5 Hz = 100K Hz / 1600 }
  SetCounterMode(Counter2C,SquareWave);
  LoadCounter(Counter2C,3200);           { 31.25 Hz = 100K Hz / 3200 }
  SetCounterMode(Counter3A,SquareWave);
  LoadCounter(Counter3A,6400);           { 15.625 Hz = 100K Hz / 6400 }
  SetCounterMode(Counter3B,SquareWave);
  LoadCounter(Counter3B,12800);          { 7.8125 Hz = 100K Hz / 12800 }

writeln('All 4I22 counters set to square wave mode')


end.
