
{ 4I22 DEMO SOFTWARE }


{$R+}    {Range checking }
{$S+}    {Stack checking }
{$I+}    {I/O checking }
{$N-}    {No numeric coprocessor}
{$L+}    {Generate Symbols}
{$F+}    {Far calls}

{$I 4I22LOW }                 { include low level 4I22 I/O }

{ program 4I22 test }

var

foonman : word;

{ This is a simple functional test of the 4I22 card. The default jumpering
  (see manual) is assumed. The test uses counter 3C as a prescaler and sets
  all other counters to the square wave mode. The output bit readback
  function is used to check that all outputs toggle. The parallel port
  check checks to see that all bits can be written and read from all
  three ports. Note that this simple test program will not detect any but
  the most major faults but is useable as a gross check of 4I22 operation }




procedure SetUpTest;

begin
  SetCounterMode(Counter3C,RateGenerator); { Set up prescaled of 1 MHz }
  LoadCounter(Counter3C,10);

  SetCounterMode(Counter1A,SquareWave);
  LoadCounter(Counter1A,10000);            { Set all counters to 100 Hz square waves }

  SetCounterMode(Counter1B,SquareWave);
  LoadCounter(Counter1B,10000);

  SetCounterMode(Counter1C,SquareWave);
  LoadCounter(Counter1C,10000);

  SetCounterMode(Counter2A,SquareWave);
  LoadCounter(Counter2A,10000);

  SetCounterMode(Counter2B,SquareWave);
  LoadCounter(Counter2B,10000);

  SetCounterMode(Counter2C,SquareWave);
  LoadCounter(Counter2C,10000);

  SetCounterMode(Counter3A,SquareWave);
  LoadCounter(Counter3A,10000);

  SetCounterMode(Counter3B,SquareWave);
  LoadCounter(Counter3B,10000);
end; { SetupTest }



procedure nothing;

begin
end; { nothing }



function OutputHigh(TimerPort : word) : boolean;
var tstatus : byte;

begin
  ReadCounterStatus(TimerPort,tstatus);
  OutputHigh := (( tstatus and OutbitMask ) = OutbitMask);
end; { OutputHigh }


procedure CountPeriod(timerPort : word; var count : integer; limit : integer);

begin
  while (OutputHigh(timerPort) and (count < limit)) do count := count + 1 ;
  while ((not OutputHigh(timerPort)) and (count < limit)) do count := count + 1 ;
end;